local Lib = MissionMinder;
Lib.callbacks = Lib.callbacks or LibStub("CallbackHandler-1.0"):New(Lib)

local options = Lib.options;
local L = LibStub("AceLocale-3.0"):GetLocale("MissionMinder");
local DEBUG = Lib.debug;

Lib.hooks = {};
local module = Lib.hooks;

local function startMission(self)
	local MissionPage = GarrisonMissionFrame.MissionTab.MissionPage
	local mission = MissionPage.missionInfo
	if (not mission) then
		return;
	end

	C_Garrison.StartMission(mission.missionID);
	PlaySound("UI_Garrison_CommandTable_MissionStart");
	Lib.callbacks:Fire("MISSION_STARTED", mission.missionID)

	GarrisonMissionList_UpdateMissions();
	GarrisonFollowerList_UpdateFollowers(GarrisonMissionFrame.FollowerList);
	GarrisonMissionPage_Close();
	if (not GetCVarBitfield("closedInfoFrames", LE_FRAME_TUTORIAL_GARRISON_LANDING)) then
		GarrisonLandingPageTutorialBox:Show();
	end
end

local function missionCompleted(self, missionID, canComplete, succeeded)
	Lib.callbacks:Fire("MISSION_COMPLETED", missionID, succeeded)
end

--[===[@alpha@
local function debugEvent(...)
	print("[EVENT]", ...)
end
--@end-alpha@]===]

local function initialize()
	DEBUG("   |cffffffffHooks|r initialized");

	-- MISSION_STARTED
	GarrisonMissionFrame.MissionTab.MissionPage.StartMissionButton:SetScript("OnClick", startMission);

	-- MISSION_COMPLETED
	local events = Lib.events
	events:RegisterEvent("hooks", "GARRISON_MISSION_COMPLETE_RESPONSE", missionCompleted)

	--[===[@alpha@
	Lib.RegisterCallback("_hooks", "MISSION_STARTED", debugEvent)
	Lib.RegisterCallback("_hooks", "MISSION_COMPLETED", debugEvent)
	--@end-alpha@]===]
end

local events = Lib.events
events:RegisterEvent("hooks", "ADDON_LOADED", initialize);
